Attribute VB_Name = "ModLexIBasic"
Enum TokedID
'Identifier     =  {ID Head} {ID Tail}*
'Head = {Letter} + [_] ,Tail= {AlphaNumeric} or [_]
'{_,A-Z,a-z}+[_,A-Z,a-z,0-9] avoid {_}+EOL = {WhiteSpace}
StringIdentifier
'{"}->{"} avoid {\"} = {"} and {\\} = {\} + Identifier
StringLiteralIdentifier
'Comment Line
'{'} -> EOL or EOF
StringComment
' Operator avoid {_}+EOL = {WhiteSpace}
'Unary or Binary(1) or Decide
' ~ ! @ # $ % ^ & * ( ) - + = | \ / ? < > , . :  _ ; '
'Unary Binary(2)
' || :: ++ --  << >> == != => >= <= =< <> >< -> *= /= \= += -= &= ^= |=
'Unary Binary(3)
'<<= >>= {Res [<=> MIO]}
Operator ' are Known Char Values Like In Above Remarks
' {space},{tab},{_}+EOL
WhiteSpace
'EOL = End Of Line: CrLf
EndOfLine
'EOF = End Of File: No More Input Data
EndOfFile
'Erorr In Getting Token
TokernError
'No Token Bootup
BeginOfFile
End Enum

Enum LexState
Identifier
StringLiteral
Comment
None
End Enum

'Type TokenPositon
'nCharStart As Long
'nCharCount As Long
'nStartLine As Long
'nEndLine As Long
'nStartCol As Long
'nEndCol As Long
'End Type

Type Token
ID As TokedID
Value As String
Identifier As String ' Only for StringLiteral Type
nCharStart As Long
nCharCount As Long
End Type

Enum CharType
Alpha '{a-z} or  {A-Z}
Numaric ' {0-9}
Known ' Operator
Unknown ' Unknown
EOL ' End of Line
EOF ' End of File(Input Stream)
Space 'Space or tab
End Enum


Private StrAlpha As String
Private StrNumaric As String
Private StrKnown As String
Private StrOperator As String

Private SrcTxt As String
Private nStart As Long

Public LTok As Token

Public Function GetLineFromChar(txt As String, nCh As Long) As Long
For I = 1 To nCh
If Left(txt, 2) = vbCrLf Then GetLineFromChar = GetLineFromChar + 1
Next
End Function
Public Function IsCharInStr(txt As String, ch As String) As Boolean
If ch = "" Then Exit Function
If InStr(1, txt, Left(ch, 1), vbBinaryCompare) > 0 And Asc(Left(ch, 1)) > 0 Then IsCharInStr = True
End Function
Public Function GetCharAt(txt As String, nIndex As Long) As String
If Len(txt) > 0 And nIndex > 0 And Len(txt) >= nIndex Then GetCharAt = Mid(txt, nIndex, 1)
End Function


Public Sub StartLex(src As String)
SrcTxt = src
Reset
'StrAlpha = {a-z} or {A-Z}
For I = Asc("A") To Asc("Z")
StrAlpha = StrAlpha + Chr(I)
Next
For I = Asc("a") To Asc("z")
StrAlpha = StrAlpha + Chr(I)
Next
'StrNumric = {0-9}
StrNumaric = "0123456789"

StrKnown = Chr(34) + "~!@#$%^&*()-+=|\/?<>,.:;_'"

StrOperator = Chr(34) + "~ ! @ # $ % ^ & * ( ) - + = | \ / ? < > , . :  _ ; '"
StrOperator = StrOperator + "|| :: ++ --  << >> == != => >= <= =< <> >< -> *= /= \= += -= &= ^= |="
End Sub

Private Function GetCharType(ch As String) As Long
Dim I As CharType
If IsCharInStr(StrKnown, ch) = True Then GetCharType = CharType.Known: Exit Function
If IsCharInStr(StrNumaric, ch) = True Then GetCharType = CharType.Numaric: Exit Function
If IsCharInStr(StrAlpha, ch) = True Then GetCharType = CharType.Alpha: Exit Function
If ch = " " Or ch = vbTab Then GetCharType = CharType.Space: Exit Function
If InStr(nStart + 1, SrcTxt, ch, vbBinaryCompare) = 1 Then GetCharType = CharType.Known: Exit Function

GetCharType = CharType.Unknown
End Function

Public Property Get TextSource() As String
TextSource = SrcTxt
End Property

Public Property Let TextSource(ByVal vNewValue As String)
StartLex vNewValue

End Property

Public Sub Reset()
nStart = 0
LTok.ID = BeginOfFile
End Sub
Private Function GetNextChar(ByRef ch As String) As Boolean
nStart = nStart + 1
If nStart <= Len(SrcTxt) Then
ch = GetCharAt(SrcTxt, nStart)
GetNextChar = True
End If
End Function
Private Sub UndoLastCharGet(ct As Long)
If nStart > 0 Then nStart = nStart - 1
If ct = CharType.EOL Then nStart = nStart - 1
End Sub
Public Function GetNextToken() As Boolean

Dim C As String  ' Cur Char
Dim P As String   'Pre Char
Dim n As String ' Next Char
Dim ct As CharType
Dim ls As LexState
ls = None
If Len(SrcTxt) < nStart Then Exit Function

While nStart <> Len(SrcTxt) + 1
'------------------Get The Type----------------------
If GetNextChar(C) = False Then
ct = EOF
Else
'///////////
If C + GetCharAt(SrcTxt, CLng(nStart + 1)) = vbCrLf Then
nStart = nStart + 1
ct = EOL
Else
ct = GetCharType(C)
End If
End If
'//////////
'-----------------------------------------------------
If ls = None Then 'New****************
'__ EOF
If ct = EOF Then
LTok.ID = EndOfFile
LTok.Value = ""
LTok.Identifier = ""
LTok.nCharCount = 0
LTok.nCharStart = Len(SrcTxt)
GetNextToken = True
Exit Function
End If
'__ EOL
If ct = EOL Then
LTok.ID = EndOfLine
LTok.Value = ""
LTok.Identifier = ""
LTok.nCharCount = 2
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If
'__WhiteSpace
'1    xyz _crlf = abc
Dim I As Long
Dim cc As Long
If (ct = Space) Or (ct = Known) Then

If (ct = Known) And C = "_" Then

If GetCharAt(SrcTxt, CLng(nStart + 1)) + GetCharAt(SrcTxt, CLng(nStart + 2)) = vbCrLf Then
cc = 3
While GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Space
cc = cc + 1
Wend
nStart = (nStart + cc) - 1

LTok.ID = WhiteSpace
LTok.Value = ""
LTok.Identifier = ""
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If 'If GetCharAt(SrcTxt, CLng(nStart + 1)) + GetCharAt(SrcTxt, CLng(nStart + 2)) = vbCrLf Then

Else
If ct = Space Then
cc = 1
While GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Space Or _
 GetCharAt(SrcTxt, CLng(nStart + cc)) + GetCharAt(SrcTxt, CLng(nStart + (cc + 2))) + GetCharAt(SrcTxt, CLng(nStart + (cc + 3))) = "_" + vbCrLf
If GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Space Then
cc = cc + 1
Else
cc = cc + 3
End If
Wend

nStart = (nStart + cc) - 1

LTok.ID = WhiteSpace
LTok.Value = ""
LTok.Identifier = ""
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If 'If (ct = Known) And C = "_" And (ct <> Space) Then

End If
End If 'If (ct = Space) Or (ct = Known) Then
'___Identifier
Dim IDF As String
If (ct = Alpha) Or C = "_" Then
cc = 1
IDF = C
    While GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Alpha _
    Or GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Numaric _
    Or GetCharAt(SrcTxt, CLng(nStart + cc)) = "_"
 
    IDF = IDF + GetCharAt(SrcTxt, CLng(nStart + cc))
       cc = cc + 1
    Wend
    
nStart = (nStart + cc) - 1

LTok.ID = StringIdentifier
LTok.Value = ""
LTok.Identifier = IDF
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If
'___Comment
If C = "'" Then
cc = 1
While GetCharAt(SrcTxt, CLng(nStart + cc)) <> "" And GetCharAt(SrcTxt, CLng(nStart + cc)) + GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) <> vbCrLf
cc = cc + 1
Wend
If GetCharAt(SrcTxt, CLng(nStart + cc)) + GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) = vbCrLf Then cc = cc + 2

nStart = (nStart + cc) - 1

LTok.ID = StringComment
LTok.Value = ""
LTok.Identifier = ""
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If
'____StringLiteralIdentifier

If C = Chr(34) Then
cc = 1
IDF = ""
While GetCharAt(SrcTxt, CLng(nStart + cc)) <> Chr(34) And GetCharAt(SrcTxt, CLng(nStart + cc)) <> "" And _
GetCharAt(SrcTxt, CLng(nStart + cc)) + GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) <> vbCrLf

If GetCharAt(SrcTxt, CLng(nStart + cc)) = "\" And (GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) = "\" Or GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) = Chr(34)) Then
IDF = IDF + GetCharAt(SrcTxt, CLng(nStart + (cc + 1)))
cc = cc + 1
Else
IDF = IDF + GetCharAt(SrcTxt, CLng(nStart + cc))
End If

cc = cc + 1
Wend

Dim SL As String
SL = IDF
IDF = ""
If GetCharAt(SrcTxt, CLng(nStart + cc)) = Chr(34) Then
cc = cc + 1
'&&&&&&&&&&&Identifier
If (GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Alpha _
    Or GetCharAt(SrcTxt, CLng(nStart + cc)) = "_") And _
    (GetCharAt(SrcTxt, CLng(nStart + cc)) <> "_" Or _
GetCharAt(SrcTxt, CLng(nStart + cc)) + GetCharAt(SrcTxt, CLng(nStart + (cc + 1))) + GetCharAt(SrcTxt, CLng(nStart + (cc + 2))) <> "_" & vbCrLf) Then

nStart = (nStart + cc) - 1

LTok.nCharCount = cc
cc = 1
IDF = ""
    While GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Alpha _
    Or GetCharType(GetCharAt(SrcTxt, CLng(nStart + cc))) = Numaric _
    Or GetCharAt(SrcTxt, CLng(nStart + cc)) = "_"
 
    IDF = IDF + GetCharAt(SrcTxt, CLng(nStart + cc))
       cc = cc + 1
    Wend
    
nStart = (nStart + cc) - 1

LTok.ID = StringLiteralIdentifier
LTok.Value = SL
LTok.Identifier = IDF
LTok.nCharCount = LTok.nCharCount + (cc - 1)
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
Else
nStart = (nStart + cc) - 1
LTok.ID = TokernError
LTok.Value = SL
LTok.Identifier = "No Identifier For Literal"
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If
'&&&&&&&&&&&&&&&&&&&
Else
nStart = (nStart + cc) - 1
LTok.ID = TokernError
LTok.Value = "Error Of StringLiteral"
LTok.Identifier = ""
LTok.nCharCount = cc
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function

End If

End If
'..............................Delim
If ct = Known Then
Dim OPr As String
Dim snArg As String
Dim snOpr As String
OPr = ""
cc = 1
While GetNthArg(StrOperator, cc) <> ""
snArg = GetNthArg(StrOperator, cc)
cc = cc + 1
snOpr = Mid(SrcTxt, nStart, Len(snArg))
If snOpr = snArg And Len(snArg) > Len(OPr) Then OPr = snArg
Wend

nStart = (nStart + Len(OPr)) - 1
LTok.ID = Operator
LTok.Value = OPr
LTok.Identifier = ""
LTok.nCharCount = Len(OPr)
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
End If
'------------
LTok.ID = TokernError
LTok.Value = ""
LTok.Identifier = "Error Uknown Text"
LTok.nCharCount = 1
LTok.nCharStart = (nStart + 1) - LTok.nCharCount
GetNextToken = True
Exit Function
'Else 'Add or Final*********************


End If


Wend



End Function

Private Function IsNthArg(ArgStr As String, nArg As Long) As Integer
Dim I As Integer
Dim nStart As Integer
Dim nEnd As Integer

nStart = 1
For I = 1 To nArg - 1
nEnd = InStr(nStart, ArgStr, " ")
If nEnd = -1 Then
IsNthArg = -1
Exit Function
End If
If nEnd <> -1 Then nStart = nEnd + 1
Next I
IsNthArg = nStart
End Function
Private Function GetNthArg(ArgStr As String, nArg As Long, Optional bAllAfterArg As Boolean = False) As String
Dim I As Integer
Dim nStart As Integer
Dim nEnd As Integer

nStart = IsNthArg(ArgStr, nArg)
If nStart = -1 Then Exit Function
If bAllAfterArg Then
GetNthArg = Mid(ArgStr, nStart)
Else

nEnd = InStr(nStart, ArgStr, " ")
If nEnd = -1 Then
GetNthArg = Mid(ArgStr, nStart)
Else
GetNthArg = Mid(ArgStr, nStart, nEnd - nStart)
End If

End If
End Function
